/[gentoo-x86]/eclass/webapp.eclass
Gentoo

Diff of /eclass/webapp.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.51 Revision 1.72
1# Copyright 1999-2006 Gentoo Foundation 1# Copyright 1999-2011 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/webapp.eclass,v 1.51 2008/02/22 13:44:41 hollow Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/webapp.eclass,v 1.72 2012/07/18 14:59:29 blueness Exp $
4# 4
5# @ECLASS: webapp.eclass 5# @ECLASS: webapp.eclass
6# @MAINTAINER: 6# @MAINTAINER:
7# web-apps@gentoo.org 7# web-apps@gentoo.org
8# @BLURB: functions for installing applications to run under a web server 8# @BLURB: functions for installing applications to run under a web server
9# @DESCRIPTION: 9# @DESCRIPTION:
10# The webapp eclass contains functions to handle web applications with 10# The webapp eclass contains functions to handle web applications with
11# webapp-config. Part of the implementation of GLEP #11 11# webapp-config. Part of the implementation of GLEP #11
12 12
13# @ECLASS-VARIABLE: WEBAPP_DEPEND
14# @DESCRIPTION:
15# An ebuild should use WEBAPP_DEPEND if a custom DEPEND needs to be built, most
16# notably in combination with WEBAPP_OPTIONAL.
17WEBAPP_DEPEND=">=app-admin/webapp-config-1.50.15"
18
19# @ECLASS-VARIABLE: WEBAPP_NO_AUTO_INSTALL
20# @DESCRIPTION:
21# An ebuild sets this to `yes' if an automatic installation and/or upgrade is
22# not possible. The ebuild should overwrite pkg_postinst() and explain the
23# reason for this BEFORE calling webapp_pkg_postinst().
24
25# @ECLASS-VARIABLE: WEBAPP_OPTIONAL
26# @DESCRIPTION:
27# An ebuild sets this to `yes' to make webapp support optional, in which case
28# you also need to take care of USE-flags and dependencies.
29
30if [[ "${WEBAPP_OPTIONAL}" != "yes" ]]; then
31 [[ "${WEBAPP_NO_AUTO_INSTALL}" == "yes" ]] || IUSE="vhosts"
13SLOT="${PVR}" 32 SLOT="${PVR}"
14IUSE="vhosts" 33 DEPEND="${WEBAPP_DEPEND}"
15DEPEND=">=app-admin/webapp-config-1.50.15"
16RDEPEND="${DEPEND}" 34 RDEPEND="${DEPEND}"
35fi
17 36
18EXPORT_FUNCTIONS pkg_postinst pkg_setup src_install pkg_prerm 37EXPORT_FUNCTIONS pkg_postinst pkg_setup src_install pkg_prerm
19 38
20INSTALL_DIR="/${PN}" 39INSTALL_DIR="/${PN}"
21IS_UPGRADE=0 40IS_UPGRADE=0
22IS_REPLACE=0 41IS_REPLACE=0
23 42
24INSTALL_CHECK_FILE="installed_by_webapp_eclass" 43INSTALL_CHECK_FILE="installed_by_webapp_eclass"
44SETUP_CHECK_FILE="setup_by_webapp_eclass"
25 45
26ETC_CONFIG="${ROOT}etc/vhosts/webapp-config" 46ETC_CONFIG="${ROOT}etc/vhosts/webapp-config"
27WEBAPP_CONFIG="${ROOT}usr/sbin/webapp-config" 47WEBAPP_CONFIG="${ROOT}usr/sbin/webapp-config"
28WEBAPP_CLEANER="${ROOT}usr/sbin/webapp-cleaner" 48WEBAPP_CLEANER="${ROOT}usr/sbin/webapp-cleaner"
29 49
37 debug-print-function $FUNCNAME $* 57 debug-print-function $FUNCNAME $*
38 58
39 if has_version '>=app-admin/webapp-config-1.50'; then 59 if has_version '>=app-admin/webapp-config-1.50'; then
40 ENVVAR=$(${WEBAPP_CONFIG} --query ${PN} ${PVR}) || die "Could not read settings from webapp-config!" 60 ENVVAR=$(${WEBAPP_CONFIG} --query ${PN} ${PVR}) || die "Could not read settings from webapp-config!"
41 eval ${ENVVAR} 61 eval ${ENVVAR}
42 else 62 elif [[ "${WEBAPP_OPTIONAL}" != "yes" ]]; then
63 # ETC_CONFIG might not be available
64 . ${ETC_CONFIG} || die "Unable to read ${ETC_CONFIG}"
65 elif [[ -f "${ETC_CONFIG}" ]]; then
66 # WEBAPP_OPTIONAL is set to yes
67 # and this must run only if ETC_CONFIG actually exists
43 . ${ETC_CONFIG} || die "Unable to read ${ETC_CONFIG}" 68 . ${ETC_CONFIG} || die "Unable to read ${ETC_CONFIG}"
44 fi 69 fi
45} 70}
46 71
47# Check whether a specified file exists in the given directory (`.' by default) 72# Check whether a specified file exists in the given directory (`.' by default)
48webapp_checkfileexists() { 73webapp_checkfileexists() {
49 debug-print-function $FUNCNAME $* 74 debug-print-function $FUNCNAME $*
50 75
51 local my_prefix 76 local my_prefix=${2:+${2}/}
52 77
53 [ -n "${2}" ] && my_prefix="${2}/" || my_prefix=
54
55 if [ ! -e "${my_prefix}${1}" ]; then 78 if [[ ! -e "${my_prefix}${1}" ]]; then
56 msg="ebuild fault: file '${1}' not found" 79 msg="ebuild fault: file '${1}' not found"
57 eerror "$msg" 80 eerror "$msg"
58 eerror "Please report this as a bug at http://bugs.gentoo.org/" 81 eerror "Please report this as a bug at http://bugs.gentoo.org/"
59 die "$msg" 82 die "$msg"
60 fi 83 fi
65 ${WEBAPP_CONFIG} --show-installed -h localhost -d "${INSTALL_DIR}" 2> /dev/null 88 ${WEBAPP_CONFIG} --show-installed -h localhost -d "${INSTALL_DIR}" 2> /dev/null
66} 89}
67 90
68webapp_strip_appdir() { 91webapp_strip_appdir() {
69 debug-print-function $FUNCNAME $* 92 debug-print-function $FUNCNAME $*
70 echo "${1}" | sed -e "s|${MY_APPDIR}/||g;" 93 echo "${1#${MY_APPDIR}/}"
71} 94}
72 95
73webapp_strip_d() { 96webapp_strip_d() {
74 debug-print-function $FUNCNAME $* 97 debug-print-function $FUNCNAME $*
75 echo "${1}" | sed -e "s|${D}||g;" 98 echo "${1#${D}}"
76} 99}
77 100
78webapp_strip_cwd() { 101webapp_strip_cwd() {
79 debug-print-function $FUNCNAME $* 102 debug-print-function $FUNCNAME $*
80 echo "${1}" | sed -e 's|/./|/|g;' 103 echo "${1/#.\///}"
81} 104}
82 105
83webapp_getinstalltype() { 106webapp_getinstalltype() {
84 debug-print-function $FUNCNAME $* 107 debug-print-function $FUNCNAME $*
85 108
86 if ! use vhosts ; then 109 if ! has vhosts ${IUSE} || use vhosts; then
110 return
111 fi
112
87 local my_output 113 local my_output
88
89 my_output="$(webapp_check_installedat)" 114 my_output="$(webapp_check_installedat)"
90 115
91 if [ "${?}" = "0" ] ; then 116 if [[ $? -eq 0 ]]; then
92 # something is already installed there 117 # something is already installed there
93 # make sure it isn't the same version 118 # make sure it isn't the same version
94 119
95 local my_pn="$(echo ${my_output} | awk '{ print $1 }')" 120 local my_pn="$(echo ${my_output} | awk '{ print $1 }')"
96 local my_pvr="$(echo ${my_output} | awk '{ print $2 }')" 121 local my_pvr="$(echo ${my_output} | awk '{ print $2 }')"
97 122
98 REMOVE_PKG="${my_pn}-${my_pvr}" 123 REMOVE_PKG="${my_pn}-${my_pvr}"
99 124
100 if [ "${my_pn}" == "${PN}" ]; then 125 if [[ "${my_pn}" == "${PN}" ]]; then
101 if [ "${my_pvr}" != "${PVR}" ]; then 126 if [[ "${my_pvr}" != "${PVR}" ]]; then
102 elog "This is an upgrade" 127 elog "This is an upgrade"
103 IS_UPGRADE=1 128 IS_UPGRADE=1
104 else 129 # for binpkgs, reset status, var declared in global scope
105 elog "This is a re-installation"
106 IS_REPLACE=1 130 IS_REPLACE=0
107 fi
108 else 131 else
109 elog "${my_output} is installed there" 132 elog "This is a re-installation"
133 IS_REPLACE=1
134 # for binpkgs, reset status, var declared in global scope
135 IS_UPGRADE=0
110 fi 136 fi
111 else 137 else
112 elog "This is an installation" 138 elog "${my_output} is installed there"
113 fi 139 fi
140 else
141 # for binpkgs, reset status, var declared in global scope
142 IS_REPLACE=0
143 IS_UPGRADE=0
144 elog "This is an installation"
114 fi 145 fi
115} 146}
116 147
117# ============================================================================== 148# ==============================================================================
118# PUBLIC FUNCTIONS 149# PUBLIC FUNCTIONS
119# ============================================================================== 150# ==============================================================================
120 151
152# @FUNCTION: need_httpd
153# @DESCRIPTION:
154# Call this function AFTER your ebuilds DEPEND line if any of the available
155# webservers are able to run this application.
156need_httpd() {
157 DEPEND="${DEPEND}
158 || ( virtual/httpd-basic virtual/httpd-cgi virtual/httpd-fastcgi )"
159}
160
161# @FUNCTION: need_httpd_cgi
162# @DESCRIPTION:
163# Call this function AFTER your ebuilds DEPEND line if any of the available
164# CGI-capable webservers are able to run this application.
165need_httpd_cgi() {
166 DEPEND="${DEPEND}
167 || ( virtual/httpd-cgi virtual/httpd-fastcgi )"
168}
169
170# @FUNCTION: need_httpd_fastcgi
171# @DESCRIPTION:
172# Call this function AFTER your ebuilds DEPEND line if any of the available
173# FastCGI-capabale webservers are able to run this application.
174need_httpd_fastcgi() {
175 DEPEND="${DEPEND}
176 virtual/httpd-fastcgi"
177}
178
121# @FUNCTION: webapp_configfile 179# @FUNCTION: webapp_configfile
122# @USAGE: <file> [more files ...] 180# @USAGE: <file> [more files ...]
123# @DESCRIPTION: 181# @DESCRIPTION:
124# Mark a file config-protected for a web-based application. 182# Mark a file config-protected for a web-based application.
125webapp_configfile() { 183webapp_configfile() {
126 debug-print-function $FUNCNAME $* 184 debug-print-function $FUNCNAME $*
127 185
128 local m="" 186 local m
129 for m in "$@" ; do 187 for m in "$@"; do
130 webapp_checkfileexists "${m}" "${D}" 188 webapp_checkfileexists "${m}" "${D}"
131 189
132 local MY_FILE="$(webapp_strip_appdir "${m}")" 190 local my_file="$(webapp_strip_appdir "${m}")"
133 MY_FILE="$(webapp_strip_cwd "${MY_FILE}")" 191 my_file="$(webapp_strip_cwd "${my_file}")"
134 192
135 elog "(config) ${MY_FILE}" 193 elog "(config) ${my_file}"
136 echo "${MY_FILE}" >> ${D}/${WA_CONFIGLIST} 194 echo "${my_file}" >> ${D}/${WA_CONFIGLIST}
137 done 195 done
138} 196}
139 197
140# @FUNCTION: webapp_hook_script 198# @FUNCTION: webapp_hook_script
141# @USAGE: <file> 199# @USAGE: <file>
174 232
175 webapp_checkfileexists "${2}" 233 webapp_checkfileexists "${2}"
176 234
177 elog "(info) ${2} (lang: ${1})" 235 elog "(info) ${2} (lang: ${1})"
178 cp "${2}" "${D}/${MY_APPDIR}/postupgrade-${1}.txt" 236 cp "${2}" "${D}/${MY_APPDIR}/postupgrade-${1}.txt"
237}
238
239# helper for webapp_serverowned()
240_webapp_serverowned() {
241 debug-print-function $FUNCNAME $*
242
243 webapp_checkfileexists "${1}" "${D}"
244 local my_file="$(webapp_strip_appdir "${1}")"
245 my_file="$(webapp_strip_cwd "${my_file}")"
246
247 elog "(server owned) ${my_file}"
248 echo "${my_file}" >> "${D}/${WA_SOLIST}"
179} 249}
180 250
181# @FUNCTION: webapp_serverowned 251# @FUNCTION: webapp_serverowned
182# @USAGE: [-R] <file> [more files ...] 252# @USAGE: [-R] <file> [more files ...]
183# @DESCRIPTION: 253# @DESCRIPTION:
185# The ownership of the file is NOT set until the application is installed using 255# The ownership of the file is NOT set until the application is installed using
186# the webapp-config tool. If -R is given directories are handled recursively. 256# the webapp-config tool. If -R is given directories are handled recursively.
187webapp_serverowned() { 257webapp_serverowned() {
188 debug-print-function $FUNCNAME $* 258 debug-print-function $FUNCNAME $*
189 259
190 local a="" 260 local a m
191 local m=""
192 if [ "${1}" = "-R" ]; then 261 if [[ "${1}" == "-R" ]]; then
193 shift 262 shift
194 for m in "$@" ; do 263 for m in "$@"; do
195 for a in $(find ${D}/${m}); do 264 find "${D}${m}" | while read a; do
196 a=${a/${D}\/\///}
197 webapp_checkfileexists "${a}" "$D"
198 local MY_FILE="$(webapp_strip_appdir "${a}")" 265 a=$(webapp_strip_d "${a}")
199 MY_FILE="$(webapp_strip_cwd "${MY_FILE}")" 266 _webapp_serverowned "${a}"
200
201 elog "(server owned) ${MY_FILE}"
202 echo "${MY_FILE}" >> "${D}/${WA_SOLIST}"
203 done 267 done
204 done 268 done
205 else 269 else
206 for m in "$@" ; do 270 for m in "$@"; do
207 webapp_checkfileexists "${m}" "$D" 271 _webapp_serverowned "${m}"
208 local MY_FILE="$(webapp_strip_appdir "${m}")"
209 MY_FILE="$(webapp_strip_cwd "${MY_FILE}")"
210
211 elog "(server owned) ${MY_FILE}"
212 echo "${MY_FILE}" >> "${D}/${WA_SOLIST}"
213 done 272 done
214 fi 273 fi
215} 274}
216 275
217# @FUNCTION: webapp_server_configfile 276# @FUNCTION: webapp_server_configfile
229 # WARNING: 288 # WARNING:
230 # 289 #
231 # do NOT change the naming convention used here without changing all 290 # do NOT change the naming convention used here without changing all
232 # the other scripts that also rely upon these names 291 # the other scripts that also rely upon these names
233 292
234 local my_file
235 if [ -z "${3}" ]; then
236 my_file="${1}-$(basename "${2}")" 293 local my_file="${1}-${3:-$(basename "${2}")}"
237 else
238 my_file="${1}-${3}"
239 fi
240 294
241 elog "(${1}) config file '${my_file}'" 295 elog "(${1}) config file '${my_file}'"
242 cp "${2}" "${D}/${MY_SERVERCONFIGDIR}/${my_file}" 296 cp "${2}" "${D}/${MY_SERVERCONFIGDIR}/${my_file}"
243} 297}
244 298
252webapp_sqlscript() { 306webapp_sqlscript() {
253 debug-print-function $FUNCNAME $* 307 debug-print-function $FUNCNAME $*
254 308
255 webapp_checkfileexists "${2}" 309 webapp_checkfileexists "${2}"
256 310
257 if [ ! -d "${D}/${MY_SQLSCRIPTSDIR}/${1}" ]; then 311 dodir "${MY_SQLSCRIPTSDIR}/${1}"
258 mkdir -p "${D}/${MY_SQLSCRIPTSDIR}/${1}" || die "unable to create directory ${D}/${MY_SQLSCRIPTSDIR}/${1}"
259 fi
260 312
261 # WARNING: 313 # WARNING:
262 # 314 #
263 # do NOT change the naming convention used here without changing all 315 # do NOT change the naming convention used here without changing all
264 # the other scripts that also rely upon these names 316 # the other scripts that also rely upon these names
265 317
266 if [ -n "${3}" ]; then 318 if [[ -n "${3}" ]]; then
267 elog "(${1}) upgrade script from ${PN}-${PVR} to ${3}" 319 elog "(${1}) upgrade script for ${PN}-${3} to ${PVR}"
268 cp "${2}" "${D}${MY_SQLSCRIPTSDIR}/${1}/${3}_to_${PVR}.sql" 320 cp "${2}" "${D}${MY_SQLSCRIPTSDIR}/${1}/${3}_to_${PVR}.sql"
269 chmod 600 "${D}${MY_SQLSCRIPTSDIR}/${1}/${3}_to_${PVR}.sql" 321 chmod 600 "${D}${MY_SQLSCRIPTSDIR}/${1}/${3}_to_${PVR}.sql"
270 else 322 else
271 elog "(${1}) create script for ${PN}-${PVR}" 323 elog "(${1}) create script for ${PN}-${PVR}"
272 cp "${2}" "${D}/${MY_SQLSCRIPTSDIR}/${1}/${PVR}_create.sql" 324 cp "${2}" "${D}/${MY_SQLSCRIPTSDIR}/${1}/${PVR}_create.sql"
279# You need to call this function in src_install() BEFORE anything else has run. 331# You need to call this function in src_install() BEFORE anything else has run.
280# For now we just create required webapp-config directories. 332# For now we just create required webapp-config directories.
281webapp_src_preinst() { 333webapp_src_preinst() {
282 debug-print-function $FUNCNAME $* 334 debug-print-function $FUNCNAME $*
283 335
336 # sanity checks, to catch bugs in the ebuild
337 if [[ ! -f "${T}/${SETUP_CHECK_FILE}" ]]; then
338 eerror
339 eerror "This ebuild did not call webapp_pkg_setup() at the beginning"
340 eerror "of the pkg_setup() function"
341 eerror
342 eerror "Please log a bug on http://bugs.gentoo.org"
343 eerror
344 eerror "You should use emerge -C to remove this package, as the"
345 eerror "installation is incomplete"
346 eerror
347 die "Ebuild did not call webapp_pkg_setup() - report to http://bugs.gentoo.org"
348 fi
349
350 # Hint, see the webapp_read_config() function to find where these are
351 # defined.
284 dodir "${MY_HTDOCSDIR}" 352 dodir "${MY_HTDOCSDIR}"
285 dodir "${MY_HOSTROOTDIR}" 353 dodir "${MY_HOSTROOTDIR}"
286 dodir "${MY_CGIBINDIR}" 354 dodir "${MY_CGIBINDIR}"
287 dodir "${MY_ICONSDIR}" 355 dodir "${MY_ICONSDIR}"
288 dodir "${MY_ERRORSDIR}" 356 dodir "${MY_ERRORSDIR}"
293 361
294# ============================================================================== 362# ==============================================================================
295# EXPORTED FUNCTIONS 363# EXPORTED FUNCTIONS
296# ============================================================================== 364# ==============================================================================
297 365
298# @FUNCTION: webapp_src_install
299# @DESCRIPTION:
300# This is the default src_install(). For now, we just make sure that root owns
301# everything, and that there are no setuid files.
302#
303# You need to call this function AFTER everything else has run in your custom
304# src_install().
305webapp_src_install() {
306 debug-print-function $FUNCNAME $*
307
308 chown -R "${VHOST_DEFAULT_UID}:${VHOST_DEFAULT_GID}" "${D}/"
309 chmod -R u-s "${D}/"
310 chmod -R g-s "${D}/"
311
312 keepdir "${MY_PERSISTDIR}"
313 fowners "root:0" "${MY_PERSISTDIR}"
314 fperms 755 "${MY_PERSISTDIR}"
315
316 # to test whether or not the ebuild has correctly called this function
317 # we add an empty file to the filesystem
318 #
319 # we used to just set a variable in the shell script, but we can
320 # no longer rely on Portage calling both webapp_src_install() and
321 # webapp_pkg_postinst() within the same shell process
322
323 touch "${D}/${MY_APPDIR}/${INSTALL_CHECK_FILE}"
324}
325
326# @FUNCTION: webapp_pkg_setup 366# @FUNCTION: webapp_pkg_setup
327# @DESCRIPTION: 367# @DESCRIPTION:
328# The default pkg_setup() for this eclass. This will gather required variables 368# The default pkg_setup() for this eclass. This will gather required variables
329# from webapp-config and check if there is an application installed to 369# from webapp-config and check if there is an application installed to
330# `${ROOT}/var/www/localhost/htdocs/${PN}/' if USE=vhosts is not set. 370# `${ROOT}/var/www/localhost/htdocs/${PN}/' if USE=vhosts is not set.
332# You need to call this function BEFORE anything else has run in your custom 372# You need to call this function BEFORE anything else has run in your custom
333# pkg_setup(). 373# pkg_setup().
334webapp_pkg_setup() { 374webapp_pkg_setup() {
335 debug-print-function $FUNCNAME $* 375 debug-print-function $FUNCNAME $*
336 376
377 # to test whether or not the ebuild has correctly called this function
378 # we add an empty file to the filesystem
379 #
380 # we used to just set a variable in the shell script, but we can
381 # no longer rely on Portage calling both webapp_pkg_setup() and
382 # webapp_src_install() within the same shell process
383 touch "${T}/${SETUP_CHECK_FILE}"
384
337 # special case - some ebuilds *do* need to overwride the SLOT 385 # special case - some ebuilds *do* need to overwride the SLOT
338 if [[ "${SLOT}+" != "${PVR}+" && "${WEBAPP_MANUAL_SLOT}" != "yes" ]]; then 386 if [[ "${SLOT}+" != "${PVR}+" && "${WEBAPP_MANUAL_SLOT}" != "yes" ]]; then
339 die "Set WEBAPP_MANUAL_SLOT=\"yes\" if you need to SLOT manually" 387 die "Set WEBAPP_MANUAL_SLOT=\"yes\" if you need to SLOT manually"
340 fi 388 fi
341 389
342 # pull in the shared configuration file 390 # pull in the shared configuration file
343 G_HOSTNAME="localhost" 391 G_HOSTNAME="localhost"
344 webapp_read_config 392 webapp_read_config
345 393
346 # are we installing a webapp-config solution over the top of a
347 # non-webapp-config solution?
348 if ! use vhosts ; then
349 local my_dir="${ROOT}${VHOST_ROOT}/${MY_HTDOCSBASE}/${PN}" 394 local my_dir="${ROOT}${VHOST_ROOT}/${MY_HTDOCSBASE}/${PN}"
395
396 # if USE=vhosts is enabled OR no application is installed we're done here
397 if ! has vhosts ${IUSE} || use vhosts || [[ ! -d "${my_dir}" ]]; then
398 return
399 fi
400
350 local my_output 401 local my_output
351
352 if [ -d "${my_dir}" ] ; then
353 my_output="$(webapp_check_installedat)" 402 my_output="$(webapp_check_installedat)"
354 403
355 if [ "$?" != "0" ]; then 404 if [[ $? -ne 0 ]]; then
356 # okay, whatever is there, it isn't webapp-config-compatible 405 # okay, whatever is there, it isn't webapp-config-compatible
406 echo
407 ewarn
357 ewarn "You already have something installed in ${my_dir}" 408 ewarn "You already have something installed in ${my_dir}"
358 ewarn 409 ewarn
359 ewarn "Whatever is in ${my_dir}, it's not" 410 ewarn "Whatever is in ${my_dir}, it's not"
360 ewarn "compatible with webapp-config." 411 ewarn "compatible with webapp-config."
361 ewarn 412 ewarn
362 ewarn "This ebuild may be overwriting important files." 413 ewarn "This ebuild may be overwriting important files."
363 ewarn 414 ewarn
364 elif [ "$(echo ${my_output} | awk '{ print $1 }')" != "${PN}" ]; then 415 echo
365 eerror "${my_dir} contains ${my_output}" 416 if has "${EAPI:-0}" 0 1 2; then
366 eerror "I cannot upgrade that" 417 ebeep 10
367 die "Cannot upgrade contents of ${my_dir}"
368 fi
369 fi 418 fi
419 elif [[ "$(echo ${my_output} | awk '{ print $1 }')" != "${PN}" ]]; then
420 echo
421 eerror "You already have ${my_output} installed in ${my_dir}"
422 eerror
423 eerror "I cannot upgrade a different application"
424 eerror
425 echo
426 die "Cannot upgrade contents of ${my_dir}"
370 fi 427 fi
428
429}
430
431# @FUNCTION: webapp_src_install
432# @DESCRIPTION:
433# This is the default src_install(). For now, we just make sure that root owns
434# everything, and that there are no setuid files.
435#
436# You need to call this function AFTER everything else has run in your custom
437# src_install().
438webapp_src_install() {
439 debug-print-function $FUNCNAME $*
440
441 # to test whether or not the ebuild has correctly called this function
442 # we add an empty file to the filesystem
443 #
444 # we used to just set a variable in the shell script, but we can
445 # no longer rely on Portage calling both webapp_src_install() and
446 # webapp_pkg_postinst() within the same shell process
447 touch "${D}/${MY_APPDIR}/${INSTALL_CHECK_FILE}"
448
449 chown -R "${VHOST_DEFAULT_UID}:${VHOST_DEFAULT_GID}" "${D}/"
450 chmod -R u-s "${D}/"
451 chmod -R g-s "${D}/"
452
453 keepdir "${MY_PERSISTDIR}"
454 fowners "root:0" "${MY_PERSISTDIR}"
455 fperms 755 "${MY_PERSISTDIR}"
371} 456}
372 457
373# @FUNCTION: webapp_pkg_postinst 458# @FUNCTION: webapp_pkg_postinst
374# @DESCRIPTION: 459# @DESCRIPTION:
375# The default pkg_postinst() for this eclass. This installs the web application to 460# The default pkg_postinst() for this eclass. This installs the web application to
382 debug-print-function $FUNCNAME $* 467 debug-print-function $FUNCNAME $*
383 468
384 webapp_read_config 469 webapp_read_config
385 470
386 # sanity checks, to catch bugs in the ebuild 471 # sanity checks, to catch bugs in the ebuild
387 if [ ! -f "${ROOT}${MY_APPDIR}/${INSTALL_CHECK_FILE}" ]; then 472 if [[ ! -f "${ROOT}${MY_APPDIR}/${INSTALL_CHECK_FILE}" ]]; then
388 eerror 473 eerror
389 eerror "This ebuild did not call webapp_src_install() at the end" 474 eerror "This ebuild did not call webapp_src_install() at the end"
390 eerror "of the src_install() function" 475 eerror "of the src_install() function"
391 eerror 476 eerror
392 eerror "Please log a bug on http://bugs.gentoo.org" 477 eerror "Please log a bug on http://bugs.gentoo.org"
395 eerror "installation is incomplete" 480 eerror "installation is incomplete"
396 eerror 481 eerror
397 die "Ebuild did not call webapp_src_install() - report to http://bugs.gentoo.org" 482 die "Ebuild did not call webapp_src_install() - report to http://bugs.gentoo.org"
398 fi 483 fi
399 484
485 if has vhosts ${IUSE}; then
400 if ! use vhosts ; then 486 if ! use vhosts; then
401 echo 487 echo
402 elog "vhosts USE flag not set - auto-installing using webapp-config" 488 elog "vhosts USE flag not set - auto-installing using webapp-config"
403 489
404 webapp_getinstalltype
405
406 G_HOSTNAME="localhost" 490 G_HOSTNAME="localhost"
407 local my_mode=-I
408 webapp_read_config 491 webapp_read_config
409 492
493 local my_mode=-I
494 webapp_getinstalltype
495
410 if [ "${IS_REPLACE}" = "1" ]; then 496 if [[ "${IS_REPLACE}" == "1" ]]; then
411 elog "${PN}-${PVR} is already installed - replacing" 497 elog "${PN}-${PVR} is already installed - replacing"
412 my_mode=-I 498 my_mode=-I
413 elif [ "${IS_UPGRADE}" = "1" ]; then 499 elif [[ "${IS_UPGRADE}" == "1" ]]; then
414 elog "${REMOVE_PKG} is already installed - upgrading" 500 elog "${REMOVE_PKG} is already installed - upgrading"
415 my_mode=-U 501 my_mode=-U
502 else
503 elog "${PN}-${PVR} is not installed - using install mode"
504 fi
505
506 my_cmd="${WEBAPP_CONFIG} ${my_mode} -h localhost -u root -d ${INSTALL_DIR} ${PN} ${PVR}"
507 elog "Running ${my_cmd}"
508 ${my_cmd}
509
510 echo
511 local cleaner="${WEBAPP_CLEANER} -p -C /${PN}"
512 einfo "Running ${cleaner}"
513 ${cleaner}
416 else 514 else
417 elog "${PN}-${PVR} is not installed - using install mode" 515 elog
516 elog "The 'vhosts' USE flag is switched ON"
517 elog "This means that Portage will not automatically run webapp-config to"
518 elog "complete the installation."
519 elog
520 elog "To install ${PN}-${PVR} into a virtual host, run the following command:"
521 elog
522 elog " webapp-config -I -h <host> -d ${PN} ${PN} ${PVR}"
523 elog
524 elog "For more details, see the webapp-config(8) man page"
418 fi 525 fi
419
420 my_cmd="${WEBAPP_CONFIG} ${my_mode} -h localhost -u root -d ${INSTALL_DIR} ${PN} ${PVR}"
421 elog "Running ${my_cmd}"
422 ${my_cmd}
423
424 echo
425 local cleaner="${WEBAPP_CLEANER} -p -C ${PN}"
426 einfo "Running ${cleaner}"
427 ${cleaner}
428 else 526 else
429 elog 527 elog
430 elog "The 'vhosts' USE flag is switched ON" 528 elog "This ebuild does not support the 'vhosts' USE flag."
431 elog "This means that Portage will not automatically run webapp-config to" 529 elog "This means that Portage will not automatically run webapp-config to"
432 elog "complete the installation." 530 elog "complete the installation."
433 elog 531 elog
434 elog "To install ${PN}-${PVR} into a virtual host, run the following command:" 532 elog "To install ${PN}-${PVR} into a virtual host, run the following command:"
435 elog 533 elog
436 elog " webapp-config -I -h <host> -d ${PN} ${PN} ${PVR}" 534 elog " webapp-config -I -h <host> -d ${PN} ${PN} ${PVR}"
437 elog 535 elog
438 elog "For more details, see the webapp-config(8) man page" 536 elog "For more details, see the webapp-config(8) man page"
439 fi 537 fi
440
441 return 0
442} 538}
443 539
444# @FUNCTION: webapp_pkg_prerm 540# @FUNCTION: webapp_pkg_prerm
445# @DESCRIPTION: 541# @DESCRIPTION:
446# This is the default pkg_prerm() for this eclass. If USE=vhosts is not set 542# This is the default pkg_prerm() for this eclass. If USE=vhosts is not set
447# remove all installed copies of this web application. Otherwise instruct the 543# remove all installed copies of this web application. Otherwise instruct the
448# user to manually remove those copies. See bug #136959. 544# user to manually remove those copies. See bug #136959.
449webapp_pkg_prerm() { 545webapp_pkg_prerm() {
450 debug-print-function $FUNCNAME $* 546 debug-print-function $FUNCNAME $*
451 547
452 local my_output 548 local my_output=
549 my_output="$(${WEBAPP_CONFIG} --list-installs ${PN} ${PVR})"
550 [[ $? -ne 0 ]] && return
551
453 local x 552 local x
454 553 if has vhosts ${IUSE} && ! use vhosts; then
455 my_output="$(${WEBAPP_CONFIG} --list-installs ${PN} ${PVR})" 554 echo "${my_output}" | while read x; do
456 555 if [[ -f "${x}"/.webapp ]]; then
457 if [ "${?}" != "0" ]; then 556 . "${x}"/.webapp
458 return
459 fi
460
461 if ! use vhosts ; then
462
463 for x in ${my_output} ; do
464 [ -f ${x}/.webapp ] && . ${x}/.webapp || ewarn "Cannot find file ${x}/.webapp"
465 if [ "${WEB_HOSTNAME}" -a "${WEB_INSTALLDIR}" ]; then 557 if [[ -n "${WEB_HOSTNAME}" && -n "${WEB_INSTALLDIR}" ]]; then
466 ${WEBAPP_CONFIG} -C -h ${WEB_HOSTNAME} -d ${WEB_INSTALLDIR} 558 ${WEBAPP_CONFIG} -C -h ${WEB_HOSTNAME} -d ${WEB_INSTALLDIR} ${PN} ${PVR}
559 fi
560 else
561 ewarn "Cannot find file ${x}/.webapp"
467 fi 562 fi
468 done 563 done
469 else 564 elif [[ "${my_output}" != "" ]]; then
470 565 echo
566 ewarn
471 ewarn "Don't forget to use webapp-config to remove any copies of" 567 ewarn "Don't forget to use webapp-config to remove any copies of"
472 ewarn "${PN}-${PVR} installed in" 568 ewarn "${PN}-${PVR} installed in"
473 ewarn 569 ewarn
474 570
475 for x in ${my_output} ; do 571 echo "${my_output}" | while read x; do
476 [ -f ${x}/.webapp ] && . ${x}/.webapp || ewarn "Cannot find file ${x}/.webapp" 572 if [[ -f "${x}"/.webapp ]]; then
477 ewarn " ${x}" 573 ewarn " ${x}"
574 else
575 ewarn "Cannot find file ${x}/.webapp"
576 fi
478 done 577 done
578
579 ewarn
580 echo
479 fi 581 fi
480} 582}

Legend:
Removed from v.1.51  
changed lines
  Added in v.1.72

  ViewVC Help
Powered by ViewVC 1.1.20